import { IDynamicHeight, ITaggleOptions } from '../interfaces';
import { IGroupData, IGroupItem } from '../model';
import Ranking from '../model/Ranking';
import { ICellRendererFactory } from '../renderer';
import { IToolbarAction, IToolbarDialogAddon } from '../ui';
export default class LineUpBuilder {
    protected readonly options: Partial<ITaggleOptions>;
    animated(enable: boolean): this;
    labelRotation(rotation: number): this;
    sidePanel(enable: boolean, collapsed?: boolean): this;
    hierarchyIndicator(enable: boolean): this;
    defaultSlopeGraphMode(mode: 'item' | 'band'): this;
    summaryHeader(enable: boolean): this;
    expandLineOnHover(enable: boolean): this;
    overviewMode(): this;
    ignoreUnsupportedBrowser(): this;
    registerRenderer(id: string, factory: ICellRendererFactory): this;
    registerToolbarAction(id: string, action: IToolbarAction): this;
    registerToolbarDialogAddon(id: string, addon: IToolbarDialogAddon): this;
    rowHeight(rowHeight: number, rowPadding: number): this;
    groupRowHeight(groupHeight: number, groupPadding: number): this;
    dynamicHeight(callback: (data: (IGroupItem | IGroupData)[], ranking: Ranking) => (IDynamicHeight | null)): this;
}
