import * as tslib_1 from "tslib";
import ColumnBuilder from './ColumnBuilder';
var StringColumnBuilder = (function (_super) {
    tslib_1.__extends(StringColumnBuilder, _super);
    function StringColumnBuilder(column) {
        return _super.call(this, 'string', column) || this;
    }
    StringColumnBuilder.prototype.editable = function () {
        this.desc.type = 'annotate';
        return this;
    };
    StringColumnBuilder.prototype.html = function () {
        this.desc.escape = false;
        return this;
    };
    StringColumnBuilder.prototype.pattern = function (pattern, templates) {
        this.desc.pattern = pattern;
        if (templates) {
            this.desc.patternTemplates = templates;
        }
        return this;
    };
    return StringColumnBuilder;
}(ColumnBuilder));
export default StringColumnBuilder;
export function buildStringColumn(column) {
    return new StringColumnBuilder(column);
}
//# sourceMappingURL=StringColumnBuilder.js.map