import * as tslib_1 from "tslib";
import { toolbar } from './annotations';
import { patternFunction } from './internal';
import MapColumn from './MapColumn';
import { default as StringColumn, EAlignment } from './StringColumn';
var StringMapColumn = (function (_super) {
    tslib_1.__extends(StringMapColumn, _super);
    function StringMapColumn(id, desc) {
        var _this = _super.call(this, id, desc) || this;
        _this.patternFunction = null;
        _this.setDefaultWidth(200);
        _this.alignment = desc.alignment || EAlignment.left;
        _this.escape = desc.escape !== false;
        _this.pattern = desc.pattern || '';
        _this.patternTemplates = desc.patternTemplates || [];
        _this.setDefaultRenderer('map');
        return _this;
    }
    StringMapColumn.prototype.setPattern = function (pattern) {
        StringColumn.prototype.setPattern.call(this, pattern);
    };
    StringMapColumn.prototype.getPattern = function () {
        return this.pattern;
    };
    StringMapColumn.prototype.createEventList = function () {
        return _super.prototype.createEventList.call(this).concat([StringColumn.EVENT_PATTERN_CHANGED]);
    };
    StringMapColumn.prototype.on = function (type, listener) {
        return _super.prototype.on.call(this, type, listener);
    };
    StringMapColumn.prototype.getValue = function (row) {
        var _this = this;
        return _super.prototype.getValue.call(this, row).map(function (_a) {
            var key = _a.key, value = _a.value;
            return ({
                key: key,
                value: _this.replacePattern(value, key, row)
            });
        });
    };
    StringMapColumn.prototype.replacePattern = function (s, key, row) {
        if (!this.pattern) {
            return s == null ? '' : String(s);
        }
        if (!this.patternFunction) {
            this.patternFunction = patternFunction(this.pattern, 'item', 'key');
        }
        return this.patternFunction.call(this, s, row.v, key);
    };
    StringMapColumn.prototype.dump = function (toDescRef) {
        var r = _super.prototype.dump.call(this, toDescRef);
        if (this.pattern !== this.desc.pattern) {
            r.pattern = this.pattern;
        }
        return r;
    };
    StringMapColumn.prototype.restore = function (dump, factory) {
        if (dump.pattern) {
            this.pattern = dump.pattern;
        }
        _super.prototype.restore.call(this, dump, factory);
    };
    StringMapColumn.EVENT_PATTERN_CHANGED = StringColumn.EVENT_PATTERN_CHANGED;
    StringMapColumn = tslib_1.__decorate([
        toolbar('search', 'editPattern')
    ], StringMapColumn);
    return StringMapColumn;
}(MapColumn));
export default StringMapColumn;
//# sourceMappingURL=StringMapColumn.js.map