import * as tslib_1 from "tslib";
import { toolbar } from './annotations';
import ArrayColumn from './ArrayColumn';
import { patternFunction } from './internal';
import StringColumn, { EAlignment } from './StringColumn';
var StringsColumn = (function (_super) {
    tslib_1.__extends(StringsColumn, _super);
    function StringsColumn(id, desc) {
        var _this = _super.call(this, id, desc) || this;
        _this.patternFunction = null;
        _this.setDefaultWidth(200);
        _this.alignment = desc.alignment || EAlignment.left;
        _this.escape = desc.escape !== false;
        _this.pattern = desc.pattern || '';
        _this.patternTemplates = desc.patternTemplates || [];
        return _this;
    }
    StringsColumn_1 = StringsColumn;
    StringsColumn.prototype.setPattern = function (pattern) {
        return StringColumn.prototype.setPattern.call(this, pattern);
    };
    StringsColumn.prototype.getPattern = function () {
        return this.pattern;
    };
    StringsColumn.prototype.createEventList = function () {
        return _super.prototype.createEventList.call(this).concat([StringsColumn_1.EVENT_PATTERN_CHANGED]);
    };
    StringsColumn.prototype.on = function (type, listener) {
        return _super.prototype.on.call(this, type, listener);
    };
    StringsColumn.prototype.getValues = function (row) {
        var _this = this;
        return _super.prototype.getValues.call(this, row).map(function (v, i) {
            if (!_this.pattern) {
                return v == null ? '' : String(v);
            }
            if (!_this.patternFunction) {
                _this.patternFunction = patternFunction(_this.pattern, 'item', 'index');
            }
            return _this.patternFunction.call(_this, v, row.v, i);
        });
    };
    StringsColumn.prototype.dump = function (toDescRef) {
        var r = _super.prototype.dump.call(this, toDescRef);
        if (this.pattern !== this.desc.pattern) {
            r.pattern = this.pattern;
        }
        return r;
    };
    StringsColumn.prototype.restore = function (dump, factory) {
        if (dump.pattern) {
            this.pattern = dump.pattern;
        }
        _super.prototype.restore.call(this, dump, factory);
    };
    var StringsColumn_1;
    StringsColumn.EVENT_PATTERN_CHANGED = StringColumn.EVENT_PATTERN_CHANGED;
    StringsColumn = StringsColumn_1 = tslib_1.__decorate([
        toolbar('search', 'editPattern')
    ], StringsColumn);
    return StringsColumn;
}(ArrayColumn));
export default StringsColumn;
//# sourceMappingURL=StringsColumn.js.map