import { renderMissingDOM } from './missing';
import { noop, noRenderer, setText } from './utils';
var DefaultCellRenderer = (function () {
    function DefaultCellRenderer() {
        this.title = 'String';
        this.groupTitle = 'None';
        this.summaryTitle = 'None';
    }
    DefaultCellRenderer.prototype.canRender = function (_col, _mode) {
        return true;
    };
    DefaultCellRenderer.prototype.create = function (col) {
        return {
            template: "<div> </div>",
            update: function (n, d) {
                renderMissingDOM(n, col, d);
                setText(n, col.getLabel(d));
            },
            render: noop
        };
    };
    DefaultCellRenderer.prototype.createGroup = function (_col) {
        return noRenderer;
    };
    DefaultCellRenderer.prototype.createSummary = function () {
        return noRenderer;
    };
    return DefaultCellRenderer;
}());
export { DefaultCellRenderer };
//# sourceMappingURL=DefaultCellRenderer.js.map