import { IColumnDesc } from '../../model';
import { IRankingHeaderContext } from '../interfaces';
import { ISearchBoxOptions } from './SearchBox';
interface IColumnDescCategory {
    label: string;
    name: string;
    order: number;
}
interface IColumnWrapper {
    desc: IColumnDesc;
    category: IColumnDescCategory;
    id: string;
    text: string;
}
export interface ISidePanelOptions extends Partial<ISearchBoxOptions<IColumnWrapper>> {
    additionalDescs: IColumnDesc[];
    chooser: boolean;
    hierarchy: boolean;
    collapseable: boolean | 'collapsed';
}
export default class SidePanel {
    private ctx;
    private readonly options;
    readonly node: HTMLElement;
    private readonly search;
    private chooser;
    private readonly descs;
    private data;
    private readonly rankings;
    constructor(ctx: IRankingHeaderContext, document: Document, options?: Partial<ISidePanelOptions>);
    private init;
    private initChooser;
    private readonly active;
    private changeDataStorage;
    private createEntry;
    collapsed: boolean;
    private makeActive;
    private updateRanking;
    update(ctx: IRankingHeaderContext): void;
    private updateStats;
    destroy(): void;
    private static groupByType;
    private updateChooser;
}
export {};
